// Unofficial VAMS-0808 RS232 interface wrapper
// Originally written by Simon Smith (opensource-ks@killswtch.net)
// http://www.killswtch.net/

using System;
using System.Collections.Generic;
using System.Text;

namespace HALibs.VAMS0808 {
	public class ChannelEnumerator : IEnumerator<int> {
		private ChannelCollection channels;
		private int currentChannel = -1;

		public ChannelEnumerator(ChannelCollection channels) {
			this.channels = channels;
		}

		#region IEnumerator<OutputChannel> Members

		public int Current {
			get { return channels[currentChannel]; }
		}

		#endregion

		#region IDisposable Members

		public void Dispose() {
			channels = null;
		}

		#endregion

		#region IEnumerator Members

		object System.Collections.IEnumerator.Current {
			get { return channels[currentChannel]; }
		}

		public bool MoveNext() {
			if (currentChannel == channels.Count - 1)
				return false;
			else {
				currentChannel++;
				return true;
			}
		}

		public void Reset() {
			currentChannel = 0;
		}

		#endregion
	}
}
